﻿<UserControl x:Class="CG_Lab3.Pages.Tutorial"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" 
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
             mc:Ignorable="d" 
             d:DesignHeight="600" d:DesignWidth="800">
    <Grid>
        <ScrollViewer Name="ScrollViewer1" VerticalScrollBarVisibility="Auto" CanContentScroll="True">
            <StackPanel Height="1600">
                <StackPanel Margin="5">
                    <Label FontWeight="Bold" FontSize="24" HorizontalContentAlignment="Center">Фрактали</Label>
                    <TextBlock TextWrapping="Wrap" xml:space="preserve">        Спочатку для гарного відображення створюється кольорова палітра як градієнт між двома вибраними користувачем кольорами. Ця палітра буде візуальною інтерпретацією ітерації на якій здійснився вихід з функції.
        Для кожного пікселя генерованого зображення ітеративно викликається функція задана в назві самого фракталу, тобто для фракталу sin(z) + c -> z_(i+1)= sin (z_i) + c, де с – початкове комплексне число, z – комплексне число, що ітеративно вираховується та використовується в умові виходу.</TextBlock>
                    <TextBlock TextWrapping="Wrap" xml:space="preserve">        Для всіх алгебраїчних фракталів використовується поняття точки виходу – умова, яка при набуванні істиності закінчує пошук ітерації для ітерованого пікселя. Умова виходу для кожного з фракталів є різною, зокрема для програми використані були такі умови виходу:</TextBlock>

                    <TextBlock HorizontalAlignment="Center" Margin="5">
                        Фрактал: sin(z) + c, умова виходу - | c | > 10π; <LineBreak/>
                        Фрактал: cos(z) + c, умова виходу - | c_imaginary | > 50; <LineBreak/>
                        Фрактал: c*sin(z), умова виходу - | c_imaginary | > 50.
                    </TextBlock>

                    <TextBlock TextWrapping="Wrap" xml:space="preserve">       Коли умова виходу для певного z_i виконається, то функція повертає індекс, тоді за цим індексом вибирається відповідний колір з кольорової палітри і відповідному пікселю (для якого проводилось вирахування ітерації) присвоюється значення цього кольору.
Ці дії повторюються для кожної точки зображення опісля чого воно зберігається та відображається на формі.
                    </TextBlock>
                </StackPanel>

                <StackPanel>
                    <Label FontSize="18" HorizontalContentAlignment="Center">Компоненти</Label>
                    <TextBlock>
                        Для початку виберіть один з запропонованих фракталів в першому блоці.
                    </TextBlock>
                    <Image Source="D:\Images\Fractal\1.png" Width="100"/>
                    <TextBlock>
                        Точність відображення фракталу (верхня межа ітерації) можна вибрати в наступному блоці з використанням слайдера.
                    </TextBlock>
                    <Image Source="D:\Images\Fractal\2.png" Width="100"/>

                    <TextBlock>
                        Останній блок відповідає за задання двох кольорів для генерування кольорової палітри.
                    </TextBlock>
                    <Image Source="D:\Images\Fractal\3.png" Width="100"/>

                    <TextBlock>
                        Для генерації та відображення зображення в правій частині екрану присутні відповідні клавіші.
                    </TextBlock>
                    <Image Source="D:\Images\Fractal\4.png" Width="100"/>

                    <TextBlock HorizontalAlignment="Center" Margin="5">
                    Принцип побудови алгебраїчного фракталу (Мандельброта)
                        <Hyperlink NavigateUri="https://youtu.be/mBg74yR3ZiY" RequestNavigate="Hyperlink_RequestNavigate">Drawing a Mandelbrot Set</Hyperlink>
                    </TextBlock>
                </StackPanel>

                <StackPanel>
                    <Label FontWeight="Bold" FontSize="24" HorizontalContentAlignment="Center">Колірні моделі</Label>

                    <Label FontSize="18" HorizontalContentAlignment="Center">Анотація</Label>
                    <TextBlock TextWrapping="Wrap" xml:space="preserve">       В кожної з моделей є свої переваги та недоліки, хоч і вони конвертуються однозначно з одного формату в інший, проте використовують їх для різних цілей, зокрема колірну модель RGB використовують для відображення забарвлення пікселя на екрані. Основною перевагою є те, що для змішування це кольорових променів для отримання потрібного відтінку ця модель є найбільш природною та простою, проте вона не містить в собі полів для зміни кольору за насиченістю чи яскравістю.</TextBlock>
                    <TextBlock TextWrapping="Wrap" xml:space="preserve">    Відповідно для цієї задачі є інша колірна схема HSV, в основному вона використовується для роботи з корекцією кольору мабуть в усіх графічних редакторах, хоч сама схема більш складна, проте для редагування вона досить природня для людини.</TextBlock>

                    <Label FontSize="18" HorizontalContentAlignment="Center">Компоненти</Label>
                    <TextBlock> 	Перший блок дозволяє вибрати зображення для редагування з файлового провідника:</TextBlock>
                    <Image Source="D:\Images\ColorModel\1.png" Width="100"/>
                    <TextBlock> В наступному блоці можна редагувати власне саму насиченість (Saturation) та яскравість (Value):</TextBlock>
                    <Image Source="D:\Images\ColorModel\2.png" Width="100"/>
                    <TextBlock> 	Останній блок відповідає за редагування лише половини зображення при вибраному перемикачі «Yes», при вибраному іншому перемикачі редагуватиметься все зображення:</TextBlock>
                    <Image Source="D:\Images\ColorModel\3.png" Width="100"/>
                    <TextBlock> В правій частині екрану можна обновити редаговане зображення а також зберегти його у файл:</TextBlock>
                    <Image Source="D:\Images\ColorModel\4.png" Width="100"/>

                    <TextBlock HorizontalAlignment="Center" Margin="5">
                        Принцип роботи кольорових моделей
                        <Hyperlink NavigateUri="https://youtu.be/cKaRxd6tdHY" RequestNavigate="Hyperlink_RequestNavigate">Color Models | RGB, HSL, HSV and CMYK</Hyperlink>
                    </TextBlock>
                </StackPanel>

                <StackPanel>
                    <Label FontWeight="Bold" FontSize="24" HorizontalContentAlignment="Center">Рух трикутника</Label>

                    <Label FontSize="18" HorizontalContentAlignment="Center">Матриці перетворень</Label>
                    <TextBlock> 	Реалізувати рух для трикутника, введеного за його вершинами, по траєкторії Y=Х. Для цього використано таку матрицю зсуву:</TextBlock>
                    <TextBlock> 	Масштабування трикутника, відповідна матриця:</TextBlock>
                    <TextBlock> 	Дзеркальне відображення відносно осі X=Y, відповідна матриця:</TextBlock>

                    <Label FontSize="18" HorizontalContentAlignment="Center">Компоненти</Label>

                    <TextBlock> 	Для задання трикутника використовується перший блок та відповідні 3 пари координат для кожної з вершин</TextBlock>
                    <Image Source="D:\Images\Movement\1.png" Width="100"/>
                    <TextBlock> 	Для того щоб сунути трикутник вздовж прямої x=y використовується відповідний слайдер</TextBlock>
                    <Image Source="D:\Images\Movement\2.png" Width="100"/>
                    <TextBlock> 	Для масштабування трикутника по кожній з осей використовуються відповідні поля масштабування (Scale)</TextBlock>
                    <Image Source="D:\Images\Movement\3.png" Width="100"/>

                    <TextBlock> 	Для масштабування самого графіку також є відповідний слайдер «Gradation» де число відповідає за крайнє положення на кожній з осей</TextBlock>
                    <Image Source="D:\Images\Movement\4.png" Width="100"/>

                    <TextBlock> 	Для відзеркалення зображення відносно осі x=y використовується відповідна кнопка “Mirror”</TextBlock>
                    <Image Source="D:\Images\Movement\5.png" Width="100"/>

                    <TextBlock> 	Щоб застосувати введені зміни натисніть клавішу «Refresh»</TextBlock>
                    <Image Source="D:\Images\Movement\6.png" Width="100"/>

                    <TextBlock HorizontalAlignment="Center" Margin="5">
                    Принцип афінних перетворень
                        <Hyperlink NavigateUri="https://youtu.be/E3Phj6J287o" RequestNavigate="Hyperlink_RequestNavigate">What are affine transformations?</Hyperlink>
                    </TextBlock>
                </StackPanel>
            </StackPanel>
        </ScrollViewer>
    </Grid>
</UserControl>
